#include "main.h"

void
file_write(const char *file, int val)
{
   char buf[80];
   int fd;
   
   snprintf(buf, sizeof(buf), "%i\n", val);
   fd = open(file, O_RDWR);
   if (fd < 0) return;
   write(fd, buf, strlen(buf));
   close(fd);
}

int
file_read(const char *file)
{
   char buf[80], *p;
   int fd, len;
   
   fd = open(file, O_RDONLY);
   if (fd < 0) return -1;
   len = read(fd, buf, sizeof(buf) - 1);
   if (len <= 0)
     {
	close(fd);
	return -1;
     }
   buf[len] = 0;
   close(fd);
   p = strchr(buf, '\n');
   if (p) *p = 0;
   return atoi(buf);
}

void
screen_off(void)
{
   // turn off backlight
   int fd;
   const char *string = "1\n";

//   putenv("DISPLAY=:0");
   // hack - force activate screensaver
//   system("xset s activate");
   fd = open("/sys/devices/platform/s3c2440-i2c/i2c-adapter/i2c-0/0-0073/backlight/pcf50633-bl/bl_power", O_RDWR);
   if (fd >= 0)
     {
	write(fd, string, sizeof(string));
	close(fd);
     }
}

void
screen_on(void)
{
   // turn backlight on
   int fd;
   const char *string = "0\n";

   fd = open("/sys/devices/platform/s3c2440-i2c/i2c-adapter/i2c-0/0-0073/backlight/pcf50633-bl/bl_power", O_RDWR);
   if (fd >= 0)
     {
	write(fd, string, sizeof(string));
	close(fd);
     }
   putenv("DISPLAY=:0");
   // hack - reset x screesanver
   system("xset s reset");
}

int
brightness_get(void)
{
   return file_read("/sys/devices/platform/s3c2440-i2c/i2c-adapter/i2c-0/0-0073/backlight/pcf50633-bl/brightness");
}

void
brightness_set(int val)
{
   file_write("/sys/devices/platform/s3c2440-i2c/i2c-adapter/i2c-0/0-0073/backlight/pcf50633-bl/brightness", val);
}

void
cpu_suspend(void)
{
   int manual_resume = 0;
   int prev_brightness;

   prev_brightness = brightness_get();
   if (prev_brightness >= 0) brightness_set(0);
   screen_off();
   
   system("apm -s");
   
   // we resumed - find out why
   manual_resume = 1;
   
   if (manual_resume)
     {
	screen_on();
	if (prev_brightness >= 0) brightness_set(prev_brightness);
     }
}

